package jdkl.PicJ.Browser;

import java.awt.*;
import java.awt.event.*;

import java.io.File;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;


/**
 * @author kmwang
 *
 * 2003/5/14 W 02:59:06
 * Browser.java
 */
public class Browser extends JPanel {
	private JPanel jpLeft, jpTreeView, jpListRoot;
	private PicJPreviewPanel jpPreview;
	
	private JTree jtDir;
	private JScrollPane scrollpane;
	private JComboBox jcb;
	
	private TreeSelectionListener getTreeSelectionListener() {
		return new TreeSelectionListener() {
			public void valueChanged(TreeSelectionEvent te) {
				TreePath tp = te.getNewLeadSelectionPath();
				Object item = tp.getLastPathComponent();
				
				//System.out.println("Selected: " + item.toString());
				
				jpPreview.setPreviewDir(item.toString());
			}
		};
	}
	
	private JScrollPane setupJSPDirTree(File root) throws 
											NullPointerException{
		JScrollPane myjsp;

		try {
			jtDir = new JTree(new FileTreeModel(root));
		} catch (Exception ex) {
			throw new NullPointerException();
		}
		
		jtDir.setCellRenderer(new FileTreeCellRender());
		jtDir.addTreeSelectionListener(getTreeSelectionListener());

		myjsp = new JScrollPane();
		myjsp.getViewport().add(jtDir);

		return myjsp;
	}
		
	public Browser() {
		// Global Initialize
		this.setLayout(new BorderLayout());
				
		jpLeft = new JPanel();
		jpLeft.setLayout(new BorderLayout());
	
		// setup jpListRoot	
		jpListRoot = new JPanel();
		File[] filelist = File.listRoots();
		File tmp = new File("C:\\");
		for (int i = 0; i < filelist.length; ++i) {
			if (filelist[i].getName().equals("C:\\")) {
				tmp = filelist[i];
			}
		}
		//jcb = new JComboBox(File.listRoots());
		jcb = new JComboBox(filelist);
		jcb.setSelectedItem(tmp);
		jcb.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JScrollPane tmpjsp;
	        	JComboBox cb = (JComboBox)e.getSource();
    
            	// Get the new item
            	Object item = cb.getSelectedItem();

				File root = new File(item.toString());
				
    			try {
    				tmpjsp = setupJSPDirTree(root);
    			} catch (Exception ex) {
    				System.err.println("error: " + root.toString() + " maybe a cd-rom without disk.");
    				return;
    			}
    			scrollpane.removeAll();
    			jpLeft.remove(scrollpane);
    			scrollpane = tmpjsp;
    			
    			jpLeft.add(scrollpane, BorderLayout.CENTER);
				jpLeft.updateUI();	
			}
			
		});
		jpListRoot.add(jcb);
		
		// setup jpDir & scrollpane
		String dir = File.listRoots()[0].toString();
		//File root = new File(dir);
		File root = new File("C:\\");
		
		scrollpane = setupJSPDirTree(root);

		// setup jpLeft(include jpDir + jpListRoot)    	
    	jpLeft.setPreferredSize(new Dimension(180, 10000));
    	jpLeft.add(jpListRoot, BorderLayout.NORTH);
    	jpLeft.add(scrollpane, BorderLayout.CENTER);

		//added by chage
		System.gc();
		//
		jpPreview = new PicJPreviewPanel(root.toString());

		// setup Global container
		add(jpLeft, BorderLayout.WEST);
		add(new JScrollPane(jpPreview, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS), 
			BorderLayout.CENTER);
	}
	
	
	
	
}
