package jdkl.PicJ.Browser;

import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.tree.*;

import java.awt.*;
import java.awt.event.*;
import java.io.File;

import jdkl.PicJ.DSP.ImageFrame;
import jdkl.PicJ.DSP.ImageComponent;
/**
 * @author kmwang
 *
 * 2003/5/14 U 08:27:53
 * PicJPreviewPanel.java
 */
public class PicJPreviewPanel extends JPanel {
	protected int ROW;
	protected int COL = 4;
	
	String[] imgList;
	JPanel[] jlImgList;
	String ppath;
	public PicJPreviewPanel(String path) {
		ppath = path;
		File curDir;
		
		curDir = new File(path);
		//assert(curDir.isDirectory());
		
		setPreviewDir(path);
		
		if (imgList != null) {
			System.out.println("preview constructor: " + curDir + "R:L = " +
				ROW + ":" + COL + " length=" + imgList.length);
		}
	}
	
	public void setPreviewDir(String path) {
		ppath = path;

		File curDir;
		Image imgTmp;
		JLabel jltmp;
		GridLayout gl;
		FlowLayout fl;
	
		removeAll();
		
		curDir = new File(path);
		//assert(curDir.isDirectory());
		
		imgList = curDir.list(new ImageFilenameFilter());
		if (imgList == null) { updateUI(); return;}
		
		ROW = imgList.length / COL + 1;
		jlImgList = new JPanel[imgList.length];
		
		gl = new GridLayout(ROW, COL);
		gl.setVgap(10);
		gl.setHgap(10);
		//setLayout(gl);
		fl = new FlowLayout(FlowLayout.LEFT);
		setLayout(fl);
		
		setPreferredSize(new Dimension(999,999));
	
		for (int i=0; i<imgList.length; i++) {
			//System.err.println("File:" + path+"\\"+imgList[i]);
			jlImgList[i] = new JPanel();
			jlImgList[i].setLayout(new BorderLayout());
			jlImgList[i].setPreferredSize(new Dimension(120, 120));
			jlImgList[i].setMaximumSize(new Dimension(120, 120));
			jlImgList[i].addMouseListener(new MouseAdapter() {
				public void mouseClicked(MouseEvent me) {
					if ((me.getClickCount() == 2) && (me.getButton() == MouseEvent.BUTTON1)) {
						Component[] com = ((JPanel)me.getSource()).getComponents();
						int j = 0;
						while (!(com[j] instanceof JLabel))
							j++;
						ImageFrame imageFrame = new ImageFrame(new File(ppath + "\\" + ((JLabel)com[j]).getText()));
					}
				}
			});
			
			jlImgList[i].setForeground(new Color(0x1f<<i));
			jltmp = new JLabel(imgList[i]);
			jltmp.setBackground(Color.GRAY);
			jltmp.setOpaque(true);
			
			jltmp.setForeground(Color.WHITE);
			jlImgList[i].add(jltmp, BorderLayout.NORTH);
			imgTmp = jlImgList[i].getToolkit().createImage(path+File.separator+imgList[i]);
			jlImgList[i].add(new ImageComponent(imgTmp, 120, 120), BorderLayout.CENTER);
			jlImgList[i].setBorder(
				new LineBorder(/*jlImgList[i].getBackground()*/ Color.black, 2, true)
				//new BevelBorder(BevelBorder.LOWERED )
			);
		
			add(jlImgList[i]);
		}
		updateUI();
			
	}
	

}
