package jdkl.PicJ.DSP;

import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

public class ImageComponent extends JComponent {

	private BufferedImage image;
	private Dimension size;

	public ImageComponent(Image image) {
		MediaTracker mt = new MediaTracker(this);
		mt.addImage(image, 0);

		try {
			mt.waitForAll();
		}
		catch (InterruptedException ie) {
			JOptionPane.showMessageDialog(this, "exception: "+ie);
		};

		int w = image.getWidth(null);
		int h = image.getHeight(null);
		this.image = new BufferedImage( w, h, BufferedImage.TYPE_INT_RGB);
		Graphics2D imageGraphics = this.image.createGraphics();
		imageGraphics.drawImage(image, 0, 0, null);

		size = new Dimension(this.image.getWidth(), this.image.getHeight());
		setSize(size);
	}

	public ImageComponent(Image image, int maxHeight, int maxWidth) { 
		float sx, sy; 
		MediaTracker mt = new MediaTracker(this); 
		mt.addImage(image, 0);
		
		try { 
			mt.waitForAll(); 
		} 
		catch (InterruptedException ie) { 
			JOptionPane.showMessageDialog(this, "exception: "+ie); 
		}; 

		Image tmp;
		if (image.getWidth(null) > image.getHeight(null)) {
			tmp = image.getScaledInstance(maxWidth - 4, -1, Image.SCALE_DEFAULT);
		} else {
			tmp = image.getScaledInstance(-1, maxHeight - 22, Image.SCALE_DEFAULT);
		}
		mt.addImage(tmp, 1);
		
		try { 
			mt.waitForAll(); 
		} 
		catch (InterruptedException ie) { 
			JOptionPane.showMessageDialog(this, "exception: "+ie); 
		}; 

		this.image = new BufferedImage(maxWidth, maxHeight,
				BufferedImage.TYPE_INT_RGB);
		Graphics2D imageGraphics = this.image.createGraphics();
		imageGraphics.drawImage(tmp, 0, 0, null);
		
		size = new Dimension(this.image.getWidth(), this.image.getHeight()); 
		setSize(size); 
	} 

	public void paint(Graphics g) {
		g.drawImage( image, 0, 0, this);
	}

	public Dimension getPreferredSize() {
		return size;
	}

	public BufferedImage getBufferedImage() {
		return image;
	}

	public void setBufferedImage(BufferedImage bimg) {
		image = bimg;

		size = new Dimension(image.getWidth(), image.getHeight());
		setSize(size);
		repaint();
	}

	public int getRGB(int x, int y) {
		return image.getRGB(x, y);
	}

}
