package jdkl.PicJ.DSP;

import java.awt.image.BufferedImage;
/*
 * Ϭ invert
 * mק hue
 * ܦⶥ calc colorLevel(ⶥ)
 * z transparency(z)
 *  colorPhase

 * g hmir
 * g vmir
 * 180 turn180
 * k90 turn90
 * 90 turn90o
 * N turn

 * ɧJ resolution(ɧJ)
 * W[I pepper
 * ҽk mean
 * hI mid median(mean(ĤG))

 * BJ pixelDifferent
 *  uniform
 */
public class ImageProcess {

	public ImageProcess() {
	}
	//invert
	public BufferedImage invert(BufferedImage bimg)
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);

		for (int y = 0; y < h; ++y )
		{
			for ( int x = 0; x < w; ++x )
			{
				int c = bimg.getRGB( x, y );
				//R-------------------------------
				int cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				int cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				int cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;
				//invert--------------------------
				cr = 255 - cr;
				cg = 255 - cg;
				cb = 255 - cb;
				resultImage.setRGB( x, y,((cr << 16)|(cg << 8)|cb));
			}
		}
		return resultImage;
	}

	//mק
	//pOʤ ձj >100 ծz <100       100ܨSt
	public BufferedImage hue(BufferedImage bimg,int p)
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);

		for (int y = 0; y < h; ++y )
		{
			for ( int x = 0; x < w; ++x )
			{
				int c = bimg.getRGB( x, y );
				//R-------------------------------
				int cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				int cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				int cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;
				//mק
				cr = (cr * p / 100 >255) ? 255 : (int)((float) cr * p /100);
				cg = (cg * p / 100 >255) ? 255 : (int)((float) cg * p /100);
				cb = (cb * p / 100 >255) ? 255 : (int)((float) cb * p /100);

				resultImage.setRGB( x, y,((cr << 16)|(cg << 8)|cb));
			}
		}
		return resultImage;
	}

	//ܦⶥ
	//call method calc
	private int calc(int value,int level)
	{
		float slip=(float)(level);//invalue [0..255];

		int a,b=1;
		a=(int)Math.round(255.0*(b/slip));
		while (a <255)
		{
			if (value <a)
				return (int)Math.round(255.0*((b-1)/(slip-1)));
			b++;
			a=(int)Math.round(255.0*(b/slip));
		}
		if (a>=255)
			return 255;
		//!need fixed here!
		else return a;
	}
	//level O 0~ 255 ⶥ~~~ `ܴNO255*255*255 (rgb)
	public BufferedImage colorLevel(BufferedImage bimg,int level)
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);

		for (int y = 0; y < h; ++y )
		{
			for ( int x = 0; x < w; ++x )
			{
				int c = bimg.getRGB( x, y );
				//R-------------------------------
				int cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				int cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				int cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;
				//invert--------------------------
				cr = calc(cr,level);
				cg = calc(cg,level);
				cb = calc(cb,level);
				resultImage.setRGB( x, y,((cr << 16)|(cg << 8)|cb));
			}
		}
		return resultImage;
	}

	//z
	//Nʤ~~~~~ݭn100%O  ٬O 50%z@b or 0% 
	public BufferedImage transparency(BufferedImage bimg,int p)//pOʤ
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);

		for (int y = 0; y < h; ++y )
		{
			for ( int x = 0; x < w; ++x )
			{
				int c = bimg.getRGB( x, y );
				//R-------------------------------
				int cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				int cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				int cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;
				//invert--------------------------
				cr = (int)(((float)cr*p/100)+(255*(100-p)/100));
				cg = (int)(((float)cg*p/100)+(255*(100-p)/100));
				cb = (int)(((float)cb*p/100)+(255*(100-p)/100));
				resultImage.setRGB( x, y,((cr << 16)|(cg << 8)|cb));
			}
		}
		return resultImage;
	}

	//
	public BufferedImage colorPhase(BufferedImage bimg,int nr,int ng,int nb)
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);

		for (int y = 0; y < h; ++y )
		{
			for ( int x = 0; x < w; ++x )
			{
				int c = bimg.getRGB( x, y );
				//R-------------------------------
				int cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				int cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				int cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;
				cr = cr*nr/255;
				cg = cg*ng/255;
				cb = cb*nb/255;
				resultImage.setRGB( x, y,((cr << 16)|(cg << 8)|cb));
			}
		}
		return resultImage;
	}

	//g
	public BufferedImage hmir(BufferedImage bimg)
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);

		for (int y = 0; y < h; ++y )
		{
			for ( int x = 0; x < w; ++x )
			{
				int c = bimg.getRGB( x, y );
				//R-------------------------------
				int cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				int cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				int cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;
				resultImage.setRGB( x, h-y-1,((cr << 16)|(cg << 8)|cb));
			}
		}
		return resultImage;
	}

	//g
	public BufferedImage vmir(BufferedImage bimg)
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);

		for (int y = 0; y < h; ++y )
		{
			for ( int x = 0; x < w; ++x )
			{
				int c = bimg.getRGB( x, y );
				//R-------------------------------
				int cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				int cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				int cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;
				resultImage.setRGB( w-x-1, y,((cr << 16)|(cg << 8)|cb));
			}
		}
		return resultImage;
	}

	//180
	public BufferedImage turn180(BufferedImage bimg)
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);

		for (int y = 0; y < h; ++y )
		{
			for ( int x = 0; x < w; ++x )
			{
				int c = bimg.getRGB( x, y );
				//R-------------------------------
				int cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				int cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				int cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;

				resultImage.setRGB(w-x-1, h-y-1,((cr << 16)|(cg << 8)|cb));
			}
		}
		return resultImage;
	}


	//k90
	public BufferedImage turn90(BufferedImage bimg)
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(h,w, BufferedImage.TYPE_INT_RGB);

		for (int y = 0; y < w; ++y )
		{
			for ( int x = 0; x < h; ++x )
			{
				int c = bimg.getRGB( y, x );
				//R-------------------------------
				int cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				int cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				int cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;

				resultImage.setRGB(h-x-1, y,((cr << 16)|(cg << 8)|cb));
			}
		}
		return resultImage;
	}

	//90
	public BufferedImage turn90o(BufferedImage bimg)
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(h,w, BufferedImage.TYPE_INT_RGB);

		for (int y = 0; y < w; ++y )
		{
			for ( int x = 0; x < h; ++x )
			{
				int c = bimg.getRGB( y, x );
				//R-------------------------------
				int cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				int cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				int cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;

				resultImage.setRGB(x, w-y-1,((cr << 16)|(cg << 8)|cb));
			}
		}
		return resultImage;
	}

	//N׼
	//int angle O׼ !bug!
	public BufferedImage turn(BufferedImage bimg,int angle)
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		int i,j;
		int fangle;
		int new_width,new_height;
		float rangle,frangle;
		float OldCenterX,OldCenterY,NewCenterX,NewCenterY;

		angle=angle%360;
		fangle=angle%90;

		rangle=(float)((angle/180.0) * Math.PI);
		frangle=(float)((fangle/180.0) * Math.PI);
		new_width=(int)(w * Math.cos(frangle) + h * Math.sin(frangle) + 1);
		new_height=(int)(h * Math.cos(frangle) + w * Math.sin(frangle) + 1);


		BufferedImage resultImage = new BufferedImage(new_width, new_height, BufferedImage.TYPE_INT_RGB);

		OldCenterX= (float)(w / 2.0);
		OldCenterY= (float)(h / 2.0);
		NewCenterX= (float)(new_width / 2.0);
		NewCenterY= (float)(new_height / 2.0);

		for (int y = 0; y < new_height; ++y )
		{
			for ( int x = 0; x < new_width; ++x )
			{
				//resultImage.setRGB( x, y,((0 << 16)|(0 << 8)|0));
				resultImage.setRGB( x, y,((255 << 16)|(255 << 8)|255));
			}
		}

		for (int y = 0; y < new_height; ++y )
		{
			for ( int x = 0; x < new_width; ++x )
			{

				i=(int)(   (x-NewCenterX) * Math.cos(rangle) + (y-NewCenterY) * Math.sin(rangle)  + OldCenterX);
				j=(int)(-1*(x-NewCenterX) * Math.sin(rangle) + (y-NewCenterY) * Math.cos(rangle)  + OldCenterY);

				//if (i<0) i=0;
				//if (i>=w) i=w-1;
				//if (j<0) j=0;
				//if (j>=h) j=h-1;

				if ((i>=0)&&(i<w)&&(j>=0)&&(j<h))
				{
					int c = bimg.getRGB( i, j );
					//R-------------------------------
					int cr = c >> 16;
					if ( cr < 0 )
						cr = cr + 256;
					//G-------------------------------
					int cg = (c >> 8)&255;
					if ( cg < 0 )
						cg = cg + 256;
					//B-------------------------------
					int cb = c&255;
					if ( cb < 0 )
						cb = cb + 256;
					resultImage.setRGB( x, y,((cr << 16)|(cg << 8)|cb));
				}
			}
		}
		return resultImage;
	}

	//ɧJ
	//dx dy NOsѪR ]쥻O512 * 512 
	//令 128 * 64 h  |128 * 64 C泣OΪ
	public BufferedImage resolution(BufferedImage bimg,int dx,int dy)
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);

		int xspan,yspan;
		xspan=Math.round((float)(w)/dx);
		yspan=Math.round((float)(h)/dy);
		int c,cr,cg,cb;
		int y = 0;
		int x = 0;
		int lastx=0,lasty=0;
		
		for (y = 0; y < h-yspan; y=y+yspan )//loop1
		{
			for (x = 0; x < w-xspan; x=x+xspan )//loop2
			{

				//DRGB
				c = bimg.getRGB( x, y );
				//R-------------------------------
				cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;
				for(int ylen=0;ylen<yspan;ylen++)//loop3
				{
					for (int xlen=0;xlen<xspan;xlen++)//loop4
					{
						resultImage.setRGB( x+xlen, y+ylen,((cr << 16)|(cg << 8)|cb));
					}
				}//loop3
			}//loop2
			lastx=x;
			//DRGB
			c = bimg.getRGB( x, y );
			//R-------------------------------
			cr = c >> 16;
			if ( cr < 0 )
				cr = cr + 256;
			//G-------------------------------
			cg = (c >> 8)&255;
			if ( cg < 0 )
				cg = cg + 256;
			//B-------------------------------
			cb = c&255;
			if ( cb < 0 )
				cb = cb + 256;
			
			for(int ylen=0;ylen<yspan;ylen++)
			{
				for (x=lastx;x<w;x++)
					resultImage.setRGB( x, y+ylen,((cr << 16)|(cg << 8)|cb));
			}
		}//loop1
		
		
		//̫@
		lasty=y;
		for (x = 0; x < w-xspan; x=x+xspan )
		{
			//DRGB
			c = bimg.getRGB( x, lasty );
			//R-------------------------------
			cr = c >> 16;
			if ( cr < 0 )
				cr = cr + 256;
			//G-------------------------------
			cg = (c >> 8)&255;
			if ( cg < 0 )
				cg = cg + 256;
			//B-------------------------------
			cb = c&255;
			if ( cb < 0 )
				cb = cb + 256;

			for (y=lasty ;y<h ;y++)
			{
				for (int xlen=0;xlen<xspan;xlen++)
				{
					resultImage.setRGB( x+xlen, y,((cr << 16)|(cg << 8)|cb));
				}
			}		
		}
		
		//̫@
		c = bimg.getRGB( lastx, lasty );
		//R-------------------------------
		cr = c >> 16;
		if ( cr < 0 )
			cr = cr + 256;
		//G-------------------------------
		cg = (c >> 8)&255;
		if ( cg < 0 )
			cg = cg + 256;
		//B-------------------------------
		cb = c&255;
		if ( cb < 0 )
			cb = cb + 256;
		for (y=lasty;y<h;y++)
		{
			for (x=lastx;x<w;x++)
			{
				resultImage.setRGB( x, y,((cr << 16)|(cg << 8)|cb));
			}
		}
		
		return resultImage;
	}

	//W[I
	public BufferedImage pepper(BufferedImage bimg)
	{
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);

		for (int y = 1; y < h-1; ++y )
		{
			for ( int x = 1; x < w-1; ++x )
			{
				int p = (int)(Math.random()*256)%64;
				int c = bimg.getRGB( x, y );
				//R-------------------------------
				int cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				int cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				int cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;

				if (p == 0)
				{	
					cr=0;
					cg=0;
					cb=0;
				}

				else if (p == 1)
				{	
					cr=255;
					cg=255;
					cb=255;
				}

				resultImage.setRGB( x, y,((cr << 16)|(cg << 8)|cb));
			}
		}
		return resultImage;
	}

	//ҽk
	public BufferedImage mean(BufferedImage bimg)
	{
		//ܼ  
		int i,j;
		int r,g,b,c;
		int a1,a2,a3,a4,a5,a6,a7,a8,a9;   
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);


		//Ĥ@
		for(j = 0; j < w; j++)
		{
			c = bimg.getRGB(j,0);      
			resultImage.setRGB(j,0,c);
		}
		//ĤGH
		for(i = 1; i < h-1;i++)
		{
			//Ĥ@
			c = bimg.getRGB(0,i);      
			resultImage.setRGB(0,i,c);

			//᪺ 
			for(j = 1; j < w-1; j++)
			{
				/////////////////////////r
				a1 = (bimg.getRGB(j,i))>>16;
				a2 = (bimg.getRGB(j-1,i-1))>>16;
				a3 = (bimg.getRGB(j-1,i))>>16;  
				a4 = (bimg.getRGB(j,i-1))>>16;
				a5 = (bimg.getRGB(j+1,i+1))>>16;
				a6 = (bimg.getRGB(j+1,i))>>16;
				a7 = (bimg.getRGB(j,i+1))>>16;
				a8 = (bimg.getRGB(j+1,i-1))>>16;
				a9 = (bimg.getRGB(j-1,i+1))>>16;
				if(a1 < 0 )
				{
					a1 = 256+a1;
				}
				if(a2 < 0 )
				{
					a2 = 256+a2;
				}
				if(a3 < 0 )
				{
					a3 = 256+a3;
				}
				if(a4 < 0 )
				{
					a4 = 256+a4;
				}
				if(a5 < 0 )
				{
					a5 = 256+a5;
				}
				if(a6 < 0 )
				{
					a6 = 256+a6;
				}
				if(a7 < 0 )
				{
					a7 = 256+a7;
				}
				if(a8 < 0 )
				{
					a8 = 256+a8;
				}
				if(a9 < 0 )
				{
					a9 = 256+a9;
				}
				r = (int)((a1+a2+a3+a4+a5+a6+a7+a8+a9)/9);
				if(r < 0 )
				{
					r = 256+r;
				}//enf of r
				////////////////////////////////////////g
				a1 = ((bimg.getRGB(j,i))>>8)&255;
				a2 = ((bimg.getRGB(j-1,i-1))>>8)&255;
				a3 = ((bimg.getRGB(j-1,i))>>8)&255;  
				a4 = ((bimg.getRGB(j,i-1))>>8)&255;
				a5 = ((bimg.getRGB(j+1,i+1))>>8)&255;
				a6 = ((bimg.getRGB(j+1,i))>>8)&255;
				a7 = ((bimg.getRGB(j,i+1))>>8)&255;
				a8 = ((bimg.getRGB(j+1,i-1))>>8)&255;
				a9 = ((bimg.getRGB(j-1,i+1))>>8)&255;
				if(a1 < 0 )
				{
					a1 = 256+a1;
				}
				if(a2 < 0 )
				{
					a2 = 256+a2;
				}
				if(a3 < 0 )
				{
					a3 = 256+a3;
				}
				if(a4 < 0 )
				{
					a4 = 256+a4;
				}
				if(a5 < 0 )
				{
					a5 = 256+a5;
				}
				if(a6 < 0 )
				{
					a6 = 256+a6;
				}
				if(a7 < 0 )
				{
					a7 = 256+a7;
				}
				if(a8 < 0 )
				{
					a8 = 256+a8;
				}
				if(a9 < 0 )
				{
					a9 = 256+a9;
				}
				g = (int)((a1+a2+a3+a4+a5+a6+a7+a8+a9)/9);
				if( g < 0)
				{
					g = g+256;
				}//end of g
				////////////////////////////////////////b
				a1 = bimg.getRGB(j,i)&255;
				a2 = bimg.getRGB(j-1,i-1)&255;
				a3 = bimg.getRGB(j-1,i)&255;  
				a4 = bimg.getRGB(j,i-1)&255;
				a5 = bimg.getRGB(j+1,i+1)&255;
				a6 = bimg.getRGB(j+1,i)&255;
				a7 = bimg.getRGB(j,i+1)&255;
				a8 = bimg.getRGB(j+1,i-1)&255;
				a9 = bimg.getRGB(j-1,i+1)&255;
				if(a1 < 0 )
				{
					a1 = 256+a1;
				}
				if(a2 < 0 )
				{
					a2 = 256+a2;
				}
				if(a3 < 0 )
				{
					a3 = 256+a3;
				}
				if(a4 < 0 )
				{
					a4 = 256+a4;
				}
				if(a5 < 0 )
				{
					a5 = 256+a5;
				}
				if(a6 < 0 )
				{
					a6 = 256+a6;
				}
				if(a7 < 0 )
				{
					a7 = 256+a7;
				}
				if(a8 < 0 )
				{
					a8 = 256+a8;
				}
				if(a9 < 0 )
				{
					a9 = 256+a9;
				}
				b = (int)((a1+a2+a3+a4+a5+a6+a7+a8+a9)/9);
				if( b < 0)
				{
					b = b+256;
				}
				//end of b
				resultImage.setRGB(j,i,((r << 16)|(g << 8)|b));
			}//end of ĤGH᪺

			//̫@
			c = bimg.getRGB((w-1),i);
			resultImage.setRGB((w-1),i,c);        
		}//end of ĤGH᪺    
		//̫@    
		for(j = 0; j < w; j++)
		{
			c = bimg.getRGB(j,h-1);
			resultImage.setRGB(j,h-1,c);     
		}  
		return resultImage;
	}

	//hI  !bug!
	//call method mid
	private int mid(int a1,int a2,int a3,int a4,int a5,int a6,int a7,int a8,int a9)
	{
		int i,j;
		int ans;
		int A[]=new int[10];

		A[0] = a1;
		A[1] = a2;
		A[2] = a3;
		A[3] = a4;
		A[4] = a5;
		A[5] = a6;
		A[6] = a7;
		A[7] = a8;
		A[8] = a9;
		for(j = 0; j < 5; j++)
		{
			for(i = j+1;i<10;i++)//o@Ӥj
			{
				if(A[j]<A[i])//je
				{
					//switch
					ans = A[j];
					A[j] = A[i];
					A[i]= ans;
				}
			}
		}
		ans = A[4];   //Ĥ  
		return(ans);
	}
	public BufferedImage median(BufferedImage bimg)
	{
		//ܼ  
		int i,j;
		int r,g,b,c;
		int a1,a2,a3,a4,a5,a6,a7,a8,a9;
		int b1,b2,b3,b4,b5,b6,b7,b8,b9;
		int c1,c2,c3,c4,c5,c6,c7,c8,c9;
		int w = bimg.getWidth();
		int h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB); 

		//Ĥ@
		for(j = 0; j < w; j++)
		{
			c = bimg.getRGB(j,0);      
			resultImage.setRGB(j,0,c);
		}
		//ĤGH
		for(i = 1; i < h-1;i++)
		{
			//Ĥ@
			c = bimg.getRGB(0,i);      
			resultImage.setRGB(0,i,c);
			//᪺ (E)
			for(j = 1; j < w-1; j++)
			{
				//r/////////////////////////////////////////////////////
				a1 = (bimg.getRGB(j,i))>>16;
				a2 = (bimg.getRGB(j-1,i-1))>>16;
				a3 = (bimg.getRGB(j-1,i))>>16;  
				a4 = (bimg.getRGB(j,i-1))>>16;
				a5 = (bimg.getRGB(j+1,i+1))>>16;
				a6 = (bimg.getRGB(j+1,i))>>16;
				a7 = (bimg.getRGB(j,i+1))>>16;
				a8 = (bimg.getRGB(j+1,i-1))>>16;
				a9 = (bimg.getRGB(j-1,i+1))>>16;
				if(a1 < 0 )
				{
					a1 = 256+a1;
				}
				if(a2 < 0 )
				{
					a2 = 256+a2;
				}
				if(a3 < 0 )
				{
					a3 = 256+a3;
				}
				if(a4 < 0 )
				{
					a4 = 256+a4;
				}
				if(a5 < 0 )
				{
					a5 = 256+a5;
				}
				if(a6 < 0 )
				{
					a6 = 256+a6;
				}
				if(a7 < 0 )
				{
					a7 = 256+a7;
				}
				if(a8 < 0 )
				{
					a8 = 256+a8;
				}
				if(a9 < 0 )
				{
					a9 = 256+a9;
				}
				//g/////////////////////////////////////////////////
				b1 = ((bimg.getRGB(j,i))>>8)&255;
				b2 = ((bimg.getRGB(j-1,i-1))>>8)&255;
				b3 = ((bimg.getRGB(j-1,i))>>8)&255;  
				b4 = ((bimg.getRGB(j,i-1))>>8)&255;
				b5 = ((bimg.getRGB(j+1,i+1))>>8)&255;
				b6 = ((bimg.getRGB(j+1,i))>>8)&255;
				b7 = ((bimg.getRGB(j,i+1))>>8)&255;
				b8 = ((bimg.getRGB(j+1,i-1))>>8)&255;
				b9 = ((bimg.getRGB(j-1,i+1))>>8)&255;
				if(b1 < 0 )
				{
					b1 = 256+b1;
				}
				if(b2 < 0 )
				{
					b2 = 256+b2;
				}
				if(b3 < 0 )
				{
					b3 = 256+b3;
				}
				if(b4 < 0 )
				{
					b4 = 256+b4;
				}
				if(b5 < 0 )
				{
					b5 = 256+b5;
				}
				if(b6 < 0 )
				{
					b6 = 256+b6;
				}
				if(b7 < 0 )
				{
					b7 = 256+b7;
				}
				if(b8 < 0 )
				{
					b8 = 256+b8;
				}
				if(b9 < 0 )
				{
					b9 = 256+b9;
				}
				//b//////////////////////////////////////         
				c1 = bimg.getRGB(j,i)&255;
				c2 = bimg.getRGB(j-1,i-1)&255;
				c3 = bimg.getRGB(j-1,i)&255;  
				c4 = bimg.getRGB(j,i-1)&255;
				c5 = bimg.getRGB(j+1,i+1)&255;
				c6 = bimg.getRGB(j+1,i)&255;
				c7 = bimg.getRGB(j,i+1)&255;
				c8 = bimg.getRGB(j+1,i-1)&255;
				c9 = bimg.getRGB(j-1,i+1)&255;
				if(c1 < 0 )
				{
					c1 = 256+c1;
				}
				if(c2 < 0 )
				{
					c2 = 256+c2;
				}
				if(c3 < 0 )
				{
					c3 = 256+c3;
				}
				if(c4 < 0 )
				{
					c4 = 256+c4;
				}
				if(c5 < 0 )
				{
					c5 = 256+c5;
				}
				if(c6 < 0 )
				{
					c6 = 256+c6;
				}
				if(c7 < 0 )
				{
					c7 = 256+c7;
				}
				if(c8 < 0 )
				{
					c8 = 256+c8;
				}
				if(c9 < 0 )
				{
					c9 = 256+c9;
				}
				r = mid(a1,a2,a3,a4,a5,a6,a7,a8,a9);
				g = mid(b1,b2,b3,b4,b5,b6,b7,b8,b9);
				b = mid(c1,c2,c3,c4,c5,c6,c7,c8,c9);
				resultImage.setRGB(j,i,((r << 16)|(g << 8)|b));         
			}
			//̫@
			c = bimg.getRGB((w-1),i);
			resultImage.setRGB((w-1),i,c);        
		}//end of ĤGH᪺    
		//̫@    
		for(j = 0; j < w; j++)
		{
			c = bimg.getRGB(j,h-1);
			resultImage.setRGB(j,h-1,c);     
		}  
		return resultImage;
	}

	//BJ
	public BufferedImage pixelDifferent(BufferedImage bimg)
	{
		//ܼư
		int firstColumn;
		int fr,fg,fb;
		int w,h;
		int c,cr,cg,cb;//᭱
		//RGB
		w = bimg.getWidth();
		h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);

		for (int y = 0; y < h; ++y )
		{
			//Ĥ@column
			firstColumn = bimg.getRGB(0,y);	        
			resultImage.setRGB(0,y,firstColumn);
			//R-------------------------------
			fr = firstColumn >> 16;
			if ( fr < 0 )
				fr = fr + 256;
			//G-------------------------------
			fg = (firstColumn >> 8)&255;
			if ( fg < 0 )
				fg = fg + 256;
			//B-------------------------------
			fb = firstColumn&255;
			if ( fb < 0 )
				fb = fb + 256;
			//᪺
			for ( int x = 1; x < w; ++x )
			{
				c = bimg.getRGB( x, y );
				//R-------------------------------
				cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;
				fr=fr-cr;
				if(fr<0) fr=fr+256;
				fg=fg-cg;
				if(fg<0) fg=fg+256;
				fb=fb-cb;
				if(fb<0) fb=fb+256;
				resultImage.setRGB( x, y,((fr << 16)|(fg << 8)|fb));
				fr=cr;
				fg=cg;
				fb=cb;
			}
		}
		return resultImage;
	}

	//
	public BufferedImage uniform(BufferedImage bimg)
	{
		//ܼư   
		int w,h;
		int c,cr,cg,cb;
		long[] R = new long[256]; //counter
		long[] G = new long[256]; //counter
		long[] B = new long[256]; //counter  
		long rtotal,gtotal,btotal; //`
		for (int i = 0; i < 256; ++i) {
			R[i] = 0;
			G[i] = 0;
			B[i] = 0;
		}
		w = bimg.getWidth();
		h = bimg.getHeight();
		BufferedImage resultImage = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB);
		//Xl
		rtotal = 0;
		gtotal = 0;
		btotal = 0;  
		//prgbUGתq  
		for(int y = 0; y < h;y++)
		{
			for(int x = 0;x < w;x++)
			{
				c = bimg.getRGB( x, y );
				//R-------------------------------
				cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;         	
				B[cb]++;
				G[cg]++;
				R[cr]++;
			}
		}

		// p֥[}C
		rtotal = R[0];
		gtotal = G[0];
		btotal = B[0];
		for(int i = 1;i < 256;i++)
		{
			rtotal = rtotal + R[i];//        
			R[i]=rtotal;
			gtotal = gtotal + G[i];//
			G[i]=gtotal;
			btotal = btotal + B[i];//
			B[i]=btotal;
		}  

		//}le
		for(int y = 0; y < h;y++)
		{
			for(int x = 0; x < w; x++)
			{
				c = bimg.getRGB( x, y );
				//R-------------------------------
				cr = c >> 16;
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				cg = (c >> 8)&255;
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				cb = c&255;
				if ( cb < 0 )
					cb = cb + 256;
				cr = (int)((255*R[cr])/rtotal);
				cg = (int)((255*G[cg])/gtotal);
				cb = (int)((255*B[cb])/btotal);
				//R-------------------------------
				if ( cr < 0 )
					cr = cr + 256;
				//G-------------------------------
				if ( cg < 0 )
					cg = cg + 256;
				//B-------------------------------
				if ( cb < 0 )
					cb = cb + 256;

				resultImage.setRGB( x, y,((cr << 16)|(cg << 8)|cb));
			}
		}
		return resultImage;  
	}

}
